## skytools3 3.0~rc1

=== Makefile ===

-include config.mak

PYTHON ?= python

pyver = $(shell $(PYTHON) -V 2>&1 | sed 's/^[^ ]* \([0-9]*\.[0-9]*\).*/\1/')

SUBDIRS = sql doc

#SCRIPTS = python/londiste.py python/qadmin.py python/pgqadm.py python/walmgr.py \
#	  scripts/queue_loader.py scripts/queue_mover.py scripts/queue_splitter.py \
#	  scripts/scriptmgr.py scripts/skytools_upgrade.py

# add suffix
SFX_SCRIPTS = python/londiste.py python/walmgr.py scripts/scriptmgr.py \
	      scripts/queue_splitter.py scripts/queue_mover.py
# dont add
NOSFX_SCRIPTS = python/qadmin.py

SCRIPT_SUFFIX = $(SUFFIX)

SQLDIR = $(prefix)/share/skytools$(SUFFIX)

# modules that use doctest for regtests
DOCTESTMODS = skytools.quoting skytools.parsing skytools.timeutil \
	   skytools.sqltools skytools.querybuilder



all: python-all sub-all config.mak

install: sub-install python-install
distclean: sub-distclean
sub-all sub-install sub-clean sub-distclean:
	for dir in $(SUBDIRS); do \
		$(MAKE) -C $$dir $(subst sub-,,$@) DESTDIR=$(DESTDIR) || exit $?; \
	done

.PHONY: sub-all sub-clean sub-install sub-distclean

python-all: config.mak
	$(PYTHON) setup_skytools.py build

clean: sub-clean
	$(PYTHON) setup_skytools.py clean
	rm -rf build
	find python -name '*.py[oc]' -print | xargs rm -f
	rm -f python/skytools/installer_config.py source.list
	rm -rf tests/londiste/sys
	rm -rf tests/londiste/file_logs
	rm -rf tests/londiste/fix.*
	rm -rf tests/scripts/sys


installcheck:
	$(MAKE) -C sql installcheck

modules-install: config.mak
	$(MAKE) -C sql install DESTDIR=$(DESTDIR)
	test \! -d compat || $(MAKE) -C compat $@ DESTDIR=$(DESTDIR)

SITEDIR = site-packages

python-install: config.mak sub-all
	mkdir -p $(DESTDIR)/$(bindir)
	rm -rf build
	$(PYTHON) setup_pkgloader.py install --prefix=$(prefix) --root=$(DESTDIR)/ $(BROKEN_PYTHON)
	find build -name 'pkgloader*' | xargs rm
	$(PYTHON) setup_skytools.py install --prefix=$(prefix) --root=$(DESTDIR)/ \
		--install-lib=$(prefix)/lib/python$(pyver)/$(SITEDIR)/skytools-3.0 \
		--record=tmp_files.lst
	for s in $(SFX_SCRIPTS); do \
		exe=`echo $$s|sed -e 's!.*/!!' -e 's/[.]py//'`; \
		install $$s $(DESTDIR)/$(bindir)/$${exe}$(SCRIPT_SUFFIX) || exit 1; \
	done
	for s in $(NOSFX_SCRIPTS); do \
		exe=`echo $$s|sed -e 's!.*/!!' -e 's/[.]py//'`; \
		install $$s $(DESTDIR)/$(bindir)/$$exe || exit 1; \
	done
	$(MAKE) -C doc DESTDIR=$(DESTDIR) install

python-install python-all: python/skytools/installer_config.py
python/skytools/installer_config.py: python/skytools/installer_config.py.in config.mak
	sed -e 's!@SQLDIR@!$(SQLDIR)!g' \
	    -e 's!@SKYLOG@!$(SKYLOG)!g' \
	    -e 's!@PACKAGE_VERSION@!$(PACKAGE_VERSION)!g' \
	    $< > $@

realclean: distclean
	$(MAKE) -C doc $@
	$(MAKE) distclean

distclean: sub-distclean
	rm -rf source.list dist skytools-*
	find python -name '*.pyc' | xargs rm -f
	rm -rf dist build
	rm -rf autom4te.cache config.log config.status config.mak

deb80:
	./configure --with-pgconfig=/usr/lib/postgresql/8.0/bin/pg_config --with-python=$(PYTHON)
	sed -e s/PGVER/8.0/g -e s/PYVER/$(pyver)/g < debian/packages.in > debian/packages
	yada rebuild
	debuild -uc -us -b

deb81:
	./configure --with-pgconfig=/usr/lib/postgresql/8.1/bin/pg_config --with-python=$(PYTHON)
	sed -e s/PGVER/8.1/g -e s/PYVER/$(pyver)/g < debian/packages.in > debian/packages
	yada rebuild
	debuild -uc -us -b

deb82:
	./configure --with-pgconfig=/usr/lib/postgresql/8.2/bin/pg_config --with-python=$(PYTHON)
	sed -e s/PGVER/8.2/g -e s/PYVER/$(pyver)/g < debian/packages.in > debian/packages
	yada rebuild
	debuild -uc -us -b

deb83:
	./configure --with-pgconfig=/usr/lib/postgresql/8.3/bin/pg_config --with-python=$(PYTHON)
	sed -e s/PGVER/8.3/g -e s/PYVER/$(pyver)/g < debian/packages.in > debian/packages
	yada rebuild
	debuild -uc -us -b

deb84:
	./configure --with-pgconfig=/usr/lib/postgresql/8.4/bin/pg_config --with-python=$(PYTHON)
	sed -e s/PGVER/8.4/g -e s/PYVER/$(pyver)/g < debian/packages.in > debian/packages
	yada rebuild
	debuild -uc -us -b

deb90:
	./configure --with-pgconfig=/usr/lib/postgresql/9.0/bin/pg_config --with-python=$(PYTHON)
	sed -e s/PGVER/9.0/g -e s/PYVER/$(pyver)/g < debian/packages.in > debian/packages
	yada rebuild
	debuild -uc -us -b

tgz: config.mak clean
	$(MAKE) -C doc man html
	rm -f source.list
	$(PYTHON) setup_skytools.py sdist -t source.cfg -m source.list

debclean: distclean
	rm -rf debian/tmp-* debian/build* debian/control debian/packages-tmp*
	rm -f debian/files debian/rules debian/sub* debian/packages

boot: configure

configure: configure.ac lib/m4/usual.m4
	aclocal -I lib/m4
	autoheader
	autoconf

tags:
	ctags `find python -name '*.py'`

check:
	./misc/docheck.sh

# workaround for Debian's broken python
debfix:
	@$(PYTHON) setup_skytools.py install --help | grep -q install-layout \
	&& echo BROKEN_PYTHON=--install-layout=deb || echo 'WORKING_PYTHON=found'

.PHONY: all clean distclean install deb debclean tgz tags
.PHONY: python-all python-clean python-install check test

test:
	@cd python; for m in $(DOCTESTMODS); do \
		printf "%-22s ... " $$m; \
		$(PYTHON) -m $$m && echo "ok" || { echo "FAIL"; exit 1; }; \
	done

=== doc/Makefile ===

include ../config.mak

web = mkz@pgf:/home/pgfoundry.org/groups/skytools/htdocs/skytools-3.0

EPYDOC = epydoc
EPYARGS = --no-private --url="http://pgfoundry.org/projects/skytools/" \
	--name="Skytools" --html --no-private -v

HTMLS = README.html INSTALL.html \
	londiste.ref.html TODO.html pgq-sql.html pgqadm.html pgq-nodupes.html \
	$(SCRIPT_HTMLS) faq.html set.notes.html skytools3.html devnotes.html

SCRIPT_TXTS = walmgr.txt queue_mover.txt queue_splitter.txt qadmin.txt \
	      scriptmgr.txt skytools_upgrade.txt londiste.txt pgqadm.txt
SCRIPT_HTMLS = $(SCRIPT_TXTS:.txt=.html)

MAN5 = 
MAN1_SFX = londiste.1 pgqadm.1 scriptmgr.1 skytools_upgrade.1 walmgr.1 \
	   queue_splitter.1 queue_mover.1
MAN1 = qadmin.1 pgqd.1

FQHTML = $(addprefix html/, $(HTMLS))
FQMAN1 = $(addprefix man/, $(MAN1))
FQMAN1_SFX = $(addprefix man/, $(MAN1_SFX))
FQMAN5 = $(addprefix man/, $(MAN5))
FQMAN = $(FQMAN1) $(FQMAN1_SFX) $(FQMAN5)

COMMON = common.switches.txt common.config.txt common.logutriga.txt

GETATTRS = python ../misc/getattrs.py
FIXMAN = python ../misc/fixman.py

#AFLAGS = -a linkcss
#AFLAGS = -a stylesheet=extra.css

all: $(FQMAN) $(FQHTML)

man: $(FQMAN)

html: $(FQHTML)

install: $(FQMAN) $(FQHTML)
	mkdir -p $(DESTDIR)/$(mandir)/man1
	mkdir -p $(DESTDIR)/$(mandir)/man5
	mkdir -p $(DESTDIR)/$(docdir)
	for m in $(FQMAN1_SFX); do \
	  xf="`basename $$m | sed 's/[.]/$(SUFFIX)./'`"; \
	  install -m 644 $$m $(DESTDIR)/$(mandir)/man1/$$xf || exit 1; \
	done
	for m in $(FQMAN1); do \
	  install -m 644 $$m $(DESTDIR)/$(mandir)/man1 || exit 1; \
	done
	for m in $(FQMAN5); do \
	  install -m 644 $$m $(DESTDIR)/$(mandir)/man5 || exit 1; \
	done
	for h in $(FQHTML); do \
	  install -m 644 $$h $(DESTDIR)/$(docdir) || exit 1; \
	done

PY_PKGS = skytools pgq londiste

#	skytools.config skytools.dbstruct skytools.gzlog \
#	skytools.quoting skytools.scripting skytools.sqltools \
#	pgq pgq.consumer pgq.event pgq.maint pgq.producer pgq.status pgq.ticker \
#	londiste londiste.compare londiste.file_read londiste.file_write \
#	londiste.installer londiste.playback londiste.repair londiste.setup \
#	londiste.syncer londiste.table_copy

apidoc:
	rm -rf api
	mkdir -p api
	cd ../python && $(EPYDOC) $(EPYARGS) -o ../doc/api $(PY_PKGS)
	cd ../sql/pgq && rm -rf docs/html && $(MAKE) dox
	cd ../sql/pgq_coop && rm -rf docs/html && $(MAKE) dox
	cd ../sql/pgq_node && rm -rf docs/html && $(MAKE) dox
	cd ../sql/londiste && rm -rf docs/html && $(MAKE) dox

apiupload: apidoc
	-rsync -rtlz api/* $(web)/api
	-rsync -rtlz ../sql/pgq/docs/html/* $(web)/pgq/
	-rsync -rtlz ../sql/pgq_coop/docs/html/* $(web)/pgq_coop/
	-rsync -rtlz ../sql/pgq_node/docs/html/* $(web)/pgq_node/
	-rsync -rtlz ../sql/londiste/docs/html/* $(web)/londiste/

clean:
	rm -rf api *.xml

distclean: clean
	rm -rf ../sql/pgq/docs/pgq

realclean: distclean
	rm -f *.[15] *.xml *.html

ifneq ($(ASCIIDOC),no)
ifneq ($(XMLTO),no)
man/%.xml: %.txt $(COMMON)
	@mkdir -p man
	$(ASCIIDOC) -b docbook -d manpage `$(GETATTRS) $<` -o - $< \
	| $(FIXMAN) > $@

man/%.1: man/%.xml
	@mkdir -p man
	$(XMLTO) -o man man $<
endif

html/%.html: %.txt $(COMMON)
	@mkdir -p html
	LANG=C cat $< \
	| sed -e '/^include/b;s,\([A-Za-z.0-9]*\)[.]txt,link:\1.html[],g' \
	| $(ASCIIDOC) $(AFLAGS) -a toc `$(GETATTRS) $<` -o - - \
	| sed -e "/^[/][*] Workarounds/r ../misc/extra.css" \
	> $@

html/README.html: ../README
	@mkdir -p html
	cat $< \
	| sed -e 's,doc/\([!-~]*\)[.]txt,link:\1.html[],g' \
	      -e 's,http:[!-~]*,&[],g' \
	| $(ASCIIDOC) $(AFLAGS) -o - - \
	| sed -e "/^[/][*] Workarounds/r ../misc/extra.css" \
	> $@

html/INSTALL.html: ../INSTALL
	@mkdir -p html
	$(ASCIIDOC) $(AFLAGS) -o - $< \
	| sed -e "/^[/][*] Workarounds/r ../misc/extra.css" \
	> $@
endif

web: $(FQHTMLS)
	rsync -avz $(FQHTML) $(web)/doc/

=== lib/Makefile ===

-include config.mak

# config
MKAR = $(AR) rcs
CFLAGS += $(WFLAGS)
CPPFLAGS = $(USUAL_CPPFLAGS)

# sources
USUAL_DIR = .
USUAL_OBJDIR = obj
USUAL_MODULES = $(filter-out pgsocket, $(subst .h,, $(notdir $(wildcard $(USUAL_DIR)/usual/*.h))))
include $(USUAL_DIR)/Setup.mk

# tgz generation
FULL = libusual-$(shell date +%Y-%m-%d)
DIRS = usual m4 test
IGNORE = usual/config.h test/config.h test/test_config.h
FILES = $(filter-out $(IGNORE), $(wildcard usual/*.[ch] test/*.[ch])) \
	m4/usual.m4 configure configure.ac COPYRIGHT \
	Makefile README config.mak.in Setup.mk \
	find_modules.sh test/force_compat.sed test/Makefile

# pgutil_kwlookup generation
PG_CONFIG ?= pg_config
KWLIST = $(shell $(PG_CONFIG) --includedir-server)/parser/kwlist.h
GPERF = gperf -m5

# full path for files
srcs = $(USUAL_SRCS)
hdrs = $(USUAL_HDRS)
objs = $(USUAL_OBJS)

# Quiet by default, 'make V=1' shows commands
V=0
ifeq ($(V), 0)
Q = @
E = @echo
else
Q =
E = @true
endif

# rules follow

all: info libusual.a obj/testcompile

libusual.a: $(objs)
	$(E) "	AR" $@
	$(Q) $(MKAR) $@ $(objs)

$(USUAL_OBJDIR)/%.o: $(USUAL_DIR)/usual/%.c config.mak $(hdrs)
	@mkdir -p $(USUAL_OBJDIR)
	$(E) "	CC" $<
	$(Q) $(CC) -c -o $@ $(DEFS) $(CPPFLAGS) $(CFLAGS) $<

$(USUAL_OBJDIR)/%.s: $(USUAL_DIR)/usual/%.c config.mak $(hdrs)
	@mkdir -p $(USUAL_OBJDIR)
	$(E) "	CC -S" $<
	$(Q) $(CC) -S -fverbose-asm -o - $(DEFS) $(CPPFLAGS) $(CFLAGS) $< \
	| cleanasm > $@

obj/testcompile: test/compile.c libusual.a config.mak $(hdrs)
	$(E) "	CHECK" $<
	$(Q) $(CC) -o $@ $(DEFS) $(CPPFLAGS) $(CFLAGS) $< $(USUAL_LDFLAGS) $(USUAL_LIBS) $(LIBS)

test/test_string: test/test_string.c libusual.a config.mak $(hdrs)
	$(E) "	TEST" $@
	$(Q) $(CC) -o $@ $(DEFS) $(CPPFLAGS) $(CFLAGS) $< $(USUAL_LDFLAGS) $(USUAL_LIBS) $(LIBS)
	$(Q) ./$@

check: config.mak
	mkdir -p test/usual
	sed -f test/compat.sed usual/config.h > test/usual/config.h
	make clean
	make CPPFLAGS="-I./test $(CPPFLAGS)" all
	make CPPFLAGS="-I./test $(CPPFLAGS)" test/test_string

clean:
	rm -f libusual.a obj/*.[os] obj/test* aclocal* config.log
	rm -rf autom4te*
	rm -f usual/pgutil_kwlookup.h.gp

distclean: clean
	rm -f config.mak usual/config.h

realclean:
	rm -f usual/pgutil_kwlookup.h

boot:
	rm -rf usual/config.*
	aclocal -I ./m4
	autoheader
	autoconf
	rm -rf aclocal* autom4te.*

#config.mak:
#	@echo "Config out-of-date, please run ./configure again"
#	@exit 1

#usual/config.h:
#	@echo "Please run ./configure first"
#	@exit 1

# run sparse over code
sparse: config.mak
	REAL_CC="$(CC)" \
	$(MAKE) clean libusual.a CC="cgcc -Wsparse-all -Wno-transparent-union"

asms = $(objs:.o=.s)
asm: $(asms)

dbg: flags
	@echo srcs=$(srcs)
	@echo objs=$(objs)
	@echo hdrs=$(hdrs)

flags:
	@echo DEFS=$(DEFS)
	@echo CFLAGS=$(CFLAGS)
	@echo CPPFLAGS=$(CPPFLAGS)

info:
	@echo CC: $(CC) $(DEFS) $(CPPFLAGS) $(CFLAGS)
	@echo LD: $(LD) $(USUAL_LDFLAGS) $(USUAL_LIBS) $(LIBS)

.PHONY: flags dbg info

# requires 8.4+
kws:
	@test -f "$(KWLIST)" || { echo "kwlist.h not found"; exit 1; }
	grep '^PG_KEYWORD' "$(KWLIST)" \
	| grep -v UNRESERVED \
	| sed 's/.*"\(.*\)",.*, *\(.*\)[)].*/\1/' \
	>> usual/pgutil_kwlookup.gp

kwh:
	$(GPERF) usual/pgutil_kwlookup.g \
	| sed '/^#line/d' \
	> usual/pgutil_kwlookup.h

tgz: config.mak $(DISTFILES)
	# create tarfile
	rm -rf $(FULL) $(FULL).tgz usual/config.h
	mkdir $(FULL)
	(for f in $(DIRS) $(FILES); do echo $$f; done) | cpio -pm $(FULL)
	tar czf $(FULL).tgz $(FULL)
	rm -rf $(FULL)

dox:
	doxygen doc/Doxyfile

=== sql/Makefile ===

include ../config.mak

SUBDIRS = londiste pgq pgq_coop pgq_ext pgq_node ticker txid

all install clean distclean installcheck:
	for dir in $(SUBDIRS); do \
	  $(MAKE) -C $$dir $@ DESTDIR=$(DESTDIR) || exit $?; \
	done

=== upgrade/Makefile ===

#SQLS = v2.1.5_londiste.sql  v2.1.5_pgq_core.sql  v2.1.5_pgq_ext.sql
#SQLS = v2.1.6_londiste.sql  v2.1.6_pgq_ext.sql
SQLS = v3.0_pgq_core.sql

SRCS = $(addprefix src/, $(SQLS))
DSTS = $(addprefix final/, $(SQLS))

CATSQL = python ../scripts/catsql.py

all: $(DSTS)

final/%.sql: src/%.sql
	$(CATSQL) $< > $@

=== lib/test/Makefile ===


SRCS = test_string.c test_crypto.c test_aatree.c test_heap.c \
       test_common.c test_list.c tinytest.c test_cbtree.c \
       test_utf8.c test_strpool.c test_pgutil.c test_regex.c \
       test_cxalloc.c test_bits.c test_base.c test_netdb.c \
       test_cfparser.c test_endian.c test_hashtab.c test_mdict.c \
       test_shlist.c test_time.c test_hashing.c test_fileutil.c
OBJS = $(addprefix obj/, $(SRCS:.c=.o))
HDRS = test_common.h test_config.h tinytest.h tinytest_macros.h
LIBS =

USUAL_DIR = ..
USUAL_OBJDIR = obj
USUAL_LOCAL_SRCS = $(SRCS) $(HDRS)
include $(USUAL_DIR)/Setup.mk
include ../config.mak

DEFS += -DUSUAL_TEST_CONFIG
CPPFLAGS += -I.. -I.

hdrs = $(HDRS) $(USUAL_HDRS)
objs = $(OBJS) $(USUAL_OBJS)

.SUFFIXES:

# Quiet by default, 'make V=1' shows commands
V=0
ifeq ($(V), 0)
Q = @
E = @echo
else
Q = 
E = @true
endif

all: regtest

obj/%.o: %.c $(hdrs)
	@mkdir -p obj
	$(E) "	CC" $<
	$(Q) $(CC) -c -o $@ $< $(DEFS) $(CFLAGS) $(CPPFLAGS) $(WFLAGS)

obj/%.o: $(USUAL_DIR)/usual/%.c $(hdrs)
	@mkdir -p obj
	$(E) "	CC" $<
	$(Q) $(CC) -c -o $@ $< $(DEFS) $(CFLAGS) $(CPPFLAGS) $(WFLAGS)

regtest: $(objs)
	$(E) "	LD" $@
	$(Q) $(CC) -o $@ $(objs) $(LIBS)

clean:
	rm -f libusual.a obj/* *.o regtest *.gcov
	rm -f config.test usual/config.h test_config.h
	rm -f regtest.compat regtest.system
	rm -f libusual_compat.a libusual_system.a

config.mak: ../config.mak
	cp ../config.mak .

test_config.h: ../usual/config.h force_compat.sed
	$(E) "	GEN-COMPAT" $<
	$(Q) sed -f force_compat.sed $< > test_config.h

sys: ../usual/config.h
	rm -f test_config.h
	cp ../usual/config.h test_config.h
	make

test: regtest
	./regtest

vcheck: regtest
	valgrind --leak-check=full ./regtest

BADGC = ../usual/base.c ../usual/signal.c
gc:
	make clean all CC="$(CC) -fprofile-arcs -ftest-coverage"
	./regtest
	gcov -f -o obj $(SRCS) $(filter-out $(BADGC), $(USUAL_SRCS)) > gc.log

=== sql/londiste/Makefile ===

DATA_built = londiste.sql londiste.upgrade.sql

SQLS = structure/tables.sql structure/grants.sql structure/functions.sql structure/triggers.sql
FUNCS = $(shell sed -e 's/^[^\\].*//' -e 's/\\i //' $(SQLS))
SRCS = $(SQLS) $(FUNCS)

REGRESS = londiste_install londiste_provider londiste_subscriber \
	  londiste_fkeys londiste_execute londiste_seqs londiste_merge \
	  londiste_leaf
# londiste_denytrigger
REGRESS_OPTS = --dbname=regression

include ../../config.mak

include $(PGXS)

londiste.sql: $(SRCS)
	$(CATSQL) $(SQLS) > $@

londiste.upgrade.sql: $(SRCS)
	$(CATSQL) structure/functions.sql > $@

test: londiste.sql
	$(MAKE) installcheck || { less regression.diffs; exit 1; }

ack:
	cp results/* expected/

NDOC = NaturalDocs
NDOCARGS = -r -o html docs/html -p docs -i docs/sql
CATSQL = ../../scripts/catsql.py

dox: cleandox
	mkdir -p docs/html
	mkdir -p docs/sql
	$(CATSQL) --ndoc structure/tables.sql > docs/sql/schema.sql
	$(CATSQL) --ndoc structure/functions.sql > docs/sql/functions.sql
	$(NDOC) $(NDOCARGS)

cleandox:
	rm -rf docs/html docs/Data docs/sql

=== sql/pgq/Makefile ===

DOCS = README.pgq
DATA_built = pgq.sql pgq.upgrade.sql
DATA = structure/uninstall_pgq.sql

# scripts that load other sql files
LDRS = structure/func_internal.sql structure/func_public.sql structure/triggers.sql
FUNCS = $(shell sed -e 's/^[^\\].*//' -e 's/\\i //' $(LDRS))
SRCS = structure/tables.sql structure/grants.sql structure/install.sql \
       structure/uninstall_pgq.sql $(FUNCS)

REGRESS = pgq_init pgq_core logutriga sqltriga trunctrg
REGRESS_OPTS = --load-language=plpgsql

include ../../config.mak
include $(PGXS)

NDOC = NaturalDocs
NDOCARGS = -r -o html docs/html -p docs -i docs/sql
CATSQL = ../../scripts/catsql.py

SUBDIRS = lowlevel triggers

# PGXS does not have subdir support, thus hack to recurse into lowlevel/
all: sub-all
install: sub-install
clean: sub-clean
distclean: sub-distclean
sub-all sub-install sub-clean sub-distclean:
	for dir in $(SUBDIRS); do \
		$(MAKE) -C $$dir $(subst sub-,,$@) DESTDIR=$(DESTDIR); \
	done

lowlevel/pgq_lowlevel.sql: sub-all
triggers/pgq_triggers.sql: sub-all

#
# combined SQL files
#

pgq.sql: $(SRCS)
	$(CATSQL) structure/install.sql > $@

# fixme: use LDRS here, to upgrade triggers
pgq.upgrade.sql: $(SRCS)
	$(CATSQL) structure/func_internal.sql structure/func_public.sql > $@

#
# docs
#
dox: cleandox $(SRCS)
	mkdir -p docs/html
	mkdir -p docs/sql
	$(CATSQL) --ndoc structure/tables.sql > docs/sql/schema.sql
	$(CATSQL) --ndoc structure/func_public.sql > docs/sql/external.sql
	$(CATSQL) --ndoc structure/func_internal.sql > docs/sql/internal.sql
	$(CATSQL) --ndoc structure/triggers.sql > docs/sql/triggers.sql
	$(NDOC) $(NDOCARGS)

cleandox:
	rm -rf docs/html docs/Data docs/sql

clean: cleandox

upload: dox
	rsync -az --delete docs/html/* data1:public_html/pgq-new/

#
# regtest shortcuts
#

test: pgq.sql
	$(MAKE) install installcheck || { less regression.diffs; exit 1; }

ack:
	cp results/*.out expected/

=== sql/pgq_coop/Makefile ===

DATA_built = pgq_coop.sql pgq_coop.upgrade.sql

SQL_FULL = structure/schema.sql structure/functions.sql
SQL_UPGRADE = structure/functions.sql

FUNCS = $(shell sed -n -e '/^\\/{s/\\i //;p}' structure/functions.sql)
SRCS = $(SQL_FULL) $(FUNCS)

REGRESS = pgq_coop_test
REGRESS_OPTS = --load-language=plpgsql

include ../../config.mak
include $(PGXS)

NDOC = NaturalDocs
NDOCARGS = -r -o html docs/html -p docs -i docs/sql
CATSQL = ../../scripts/catsql.py

#
# combined SQL files
#

pgq_coop.sql: $(SRCS)
	$(CATSQL) $(SQL_FULL) > $@

pgq_coop.upgrade.sql: $(SRCS)
	$(CATSQL) $(SQL_UPGRADE) > $@

#
# docs
#
dox: cleandox $(SRCS)
	mkdir -p docs/html
	mkdir -p docs/sql
	$(CATSQL) --ndoc structure/functions.sql > docs/sql/functions.sql
	$(NDOC) $(NDOCARGS)

cleandox:
	rm -rf docs/html docs/Data docs/sql

clean: cleandox

upload: dox
	rsync -az --delete docs/html/* data1:public_html/pgq-set/

#
# regtest shortcuts
#

test: pgq_coop.sql
	$(MAKE) installcheck || { less regression.diffs; exit 1; }

ack:
	cp results/*.out expected/

=== sql/pgq_node/Makefile ===

DATA_built = pgq_node.sql pgq_node.upgrade.sql

LDRS = structure/functions.sql
FUNCS = $(shell sed -e 's/^[^\\].*//' -e 's/\\i //' $(LDRS))
SRCS = structure/tables.sql structure/functions.sql $(FUNCS)

REGRESS = pgq_node_test
REGRESS_OPTS = --load-language=plpgsql

include ../../config.mak
include $(PGXS)

NDOC = NaturalDocs
NDOCARGS = -r -o html docs/html -p docs -i docs/sql
CATSQL = ../../scripts/catsql.py

#
# combined SQL files
#

pgq_node.sql: $(SRCS)
	$(CATSQL) structure/tables.sql structure/functions.sql > $@

pgq_node.upgrade.sql: $(SRCS)
	$(CATSQL) structure/functions.sql > $@

#
# docs
#
dox: cleandox $(SRCS)
	mkdir -p docs/html
	mkdir -p docs/sql
	$(CATSQL) --ndoc structure/tables.sql > docs/sql/pgq_node.sql
	$(CATSQL) --ndoc structure/functions.sql > docs/sql/functions.sql
	$(NDOC) $(NDOCARGS)

cleandox:
	rm -rf docs/html docs/Data docs/sql

clean: cleandox

upload: dox
	rsync -az --delete docs/html/* data1:public_html/pgq-set/

#
# regtest shortcuts
#

test: pgq_node.sql
	$(MAKE) installcheck || { less regression.diffs; exit 1; }

ack:
	cp results/*.out expected/

=== sql/ticker/Makefile ===

include ../../config.mak

SRCS = pgqd.c maint.c ticker.c retry.c
LOCAL_HDRS = pgqd.h

USUAL_DIR = ../../lib
USUAL_OBJDIR = .
USUAL_LOCAL_SRCS = $(SRCS) $(LOCAL_HDRS)
include $(USUAL_DIR)/Setup.mk

PROGRAM = pgqd

HDRS = $(LOCAL_HDRS) $(USUAL_HDRS)

PG_INCDIR = $(shell $(PG_CONFIG) --includedir)
PG_LIBDIR = $(shell $(PG_CONFIG) --libdir)
PG_CPPFLAGS = -I$(PG_INCDIR)
PG_LDFLAGS = -L$(PG_LIBDIR)
PG_LIBS = -lpq -lm

OBJS = $(SRCS:.c=.o) $(USUAL_OBJS)

CPPFLAGS += $(USUAL_CPPFLAGS) $(PG_CPPFLAGS)
LDFLAGS += $(PG_LDFLAGS)
LIBS += $(PG_LIBS)

all: $(PROGRAM)

$(PROGRAM): $(OBJS)
	$(CC) -o $@ $(OBJS) $(LDFLAGS) $(LIBS)

$(OBJS): $(HDRS)

%.o: $(USUAL_DIR)/usual/%.c $(USUAL_HDRS)
	$(CC) $(CFLAGS) $(CPPFLAGS) $(DEFS) -c -o $@ $<

pgqd.o: pgqd.ini.h
pgqd.ini.h: pgqd.ini
	sed -e 's/.*/"&\\n"/' $< > $@

install: all
	mkdir -p '$(DESTDIR)$(bindir)'
	$(BININSTALL) -m 755 pgqd$(X) '$(DESTDIR)$(bindir)/pgqd'
	mkdir -p '$(DESTDIR)$(docdir)/conf'
	$(INSTALL) -m 644 pgqd.ini '$(DESTDIR)$(docdir)/conf/pgqd.ini.templ'

clean:
	rm -f $(PROGRAM) $(OBJS) pgqd.ini.h

tags:
	ctags *.[ch] ../../lib/usual/*.[ch]

distclean: clean
installcheck:

=== sql/txid/Makefile ===

include ../../config.mak

PGVER := $(shell $(PG_CONFIG) --version | sed 's/PostgreSQL //')

ifeq ($(PGVER),)
$(error skytools not configured, cannot continue)
else
# postgres >= manages epoch itself, so skip epoch tables
pg83 = $(shell test $(PGVER) "<" "8.3" && echo "false" || echo "true")
pg82 = $(shell test $(PGVER) "<" "8.2" && echo "false" || echo "true")
endif

ifeq ($(pg83),true)  # we have 8.3 with internal txid

# install empty txid.sql
DATA_built = txid.sql
include $(PGXS)
txid.sql: txid.internal.sql
	cp $< $@

else # 8.2 or 8.1
#
# pg < 8.3 needs this module
#
MODULE_big = txid
SRCS = txid.c epoch.c
OBJS = $(SRCS:.c=.o)
REGRESS = txid
REGRESS_OPTS = --load-language=plpgsql
DATA = uninstall_txid.sql
DOCS = README.txid
DATA_built = txid.sql
EXTRA_CLEAN = txid.sql.in

# PGXS build procedure
include $(PGXS)

ifeq ($(pg82),true)
# 8.2 tracks epoch internally
TXID_SQL = txid.std.sql
else
# 8.1 needs epoch-tracking code
TXID_SQL = txid.std.sql txid.schema.sql
endif # ! 8.2

# additional deps
txid.o: txid.h
epoch.o: txid.h

txid.sql.in: $(TXID_SQL)
	cat $(TXID_SQL) > $@

endif # ! 8.3

test: install
	make installcheck || { less regression.diffs; exit 1; }

=== debian/changelog ===
skytools3 (3.0~rc1-2) experimental; urgency=low

  * Add automake to the Build Depends (Closes: #632574)
  * Merge with upstream

 -- Dimitri Fontaine <dim@tapoueh.org>  Wed, 06 Jul 2011 16:07:12 +0200

skytools3 (3.0~rc1-1) experimental; urgency=low

  * New upstream version of skytools (Closes: #621115)

 -- Dimitri Fontaine <dim@tapoueh.org>  Mon, 28 Mar 2011 14:28:13 +0200

skytools3 (3.0~a1-1) unstable; urgency=low

  * 3.0a1

 -- Marko Kreen <marko.kreen@skype.net>  Mon, 13 Apr 2009 17:16:02 +0300

skytools3 (3.0~a-0) unstable; urgency=low

  * dev tree for 3.0

 -- Marko Kreen <marko.kreen@skype.net>  Fri, 13 Feb 2009 17:33:55 +0200

skytools (2.1.12) unstable; urgency=low

  * v2.1.12

 -- Marko Kreen <marko.kreen@skype.net>  Wed, 10 Nov 2010 15:23:59 +0200

skytools (2.1.12rc2) unstable; urgency=low

  * v2.1.12rc2

 -- Marko Kreen <marko.kreen@skype.net>  Tue, 05 Oct 2010 11:43:38 +0300

skytools (2.1.12rc1) unstable; urgency=low

  * v2.1.12rc1

 -- Marko Kreen <marko.kreen@skype.net>  Tue, 21 Sep 2010 07:26:22 -0700

skytools (2.1.11) unstable; urgency=low

  * v2.1.11

 -- Marko Kreen <marko.kreen@skype.net>  Wed, 03 Feb 2010 18:28:57 +0200

skytools (2.1.11rc1) unstable; urgency=low

  * v2.1.11rc1

 -- Marko Kreen <marko.kreen@skype.net>  Fri, 30 Oct 2009 18:05:58 +0200

skytools (2.1.10) unstable; urgency=low

  * v2.1.10

 -- Marko Kreen <marko.kreen@skype.net>  Mon, 31 Aug 2009 16:44:53 +0300

skytools (2.1.10rc1) unstable; urgency=low

  * v2.1.10rc1

 -- Marko Kreen <marko.kreen@skype.net>  Mon, 17 Aug 2009 15:52:16 +0300

skytools (2.1.9) unstable; urgency=low

  * v2.1.9

 -- Marko Kreen <marko.kreen@skype.net>  Fri, 13 Mar 2009 15:39:18 +0200

skytools (2.1.9rc1) unstable; urgency=low

  * v2.1.9rc1

 -- Marko Kreen <marko.kreen@skype.net>  Thu, 26 Feb 2009 14:50:49 +0200

skytools (2.1.8) unstable; urgency=low

  * v2.1.8

 -- Marko Kreen <marko.kreen@skype.net>  Sun, 12 Oct 2008 13:29:09 +0300

skytools (2.1.8rc1) unstable; urgency=low

  * v2.1.8rc1

 -- Marko Kreen <marko.kreen@skype.net>  Mon, 22 Sep 2008 16:31:27 +0300

skytools (2.1.7) unstable; urgency=low

  * v2.1.7

 -- Marko Kreen <marko.kreen@skype.net>  Wed, 28 May 2008 17:04:32 +0300

skytools (2.1.6) unstable; urgency=low

  * Final release

 -- Marko Kreen <marko.kreen@skype.net>  Sat, 05 Apr 2008 16:45:11 +0300

skytools (2.1.6rc3) unstable; urgency=low

  * quoting/parsing fixes
  ? walmgr fix

 -- Marko Kreen <marko.kreen@skype.net>  Wed, 12 Mar 2008 15:43:39 +0200

skytools (2.1.6rc2) unstable; urgency=low

  * Bugfix release.

 -- Marko Kreen <marko.kreen@skype.net>  Fri, 07 Dec 2007 16:12:27 +0200

skytools (2.1.5) unstable; urgency=low

  * New public release.

 -- Marko Kreen <marko.kreen@skype.net>  Mon, 19 Nov 2007 15:32:41 +0200

skytools (2.1.4) unstable; urgency=low

  * Upgrade walmgr, some fixes.

 -- Marko Kreen <marko.kreen@skype.net>  Fri, 13 Apr 2007 11:08:41 +0300

skytools (2.1.3) unstable; urgency=low

  * brown paper bag

 -- Marko Kreen <marko.kreen@skype.net>  Tue, 10 Apr 2007 11:55:47 +0300

skytools (2.1.2) unstable; urgency=low

  * more bugfixes

 -- Marko Kreen <marko.kreen@skype.net>  Mon, 09 Apr 2007 17:56:35 +0300

skytools (2.1.1) unstable; urgency=low

  * bugfixes

 -- Marko Kreen <marko.kreen@skype.net>  Tue, 03 Apr 2007 15:03:28 +0300

skytools (2.1) unstable; urgency=low

  * cleanup

 -- Marko Kreen <marko.kreen@skype.net>  Fri, 02 Feb 2007 12:38:17 +0200

=== debian/control ===
Source: skytools3
Section: database
Priority: extra
Maintainer: Dimitri Fontaine <dim@tapoueh.org>
Build-Depends: debhelper (>= 7.0.50~), autotools-dev, autoconf (>= 2.65), automake, libevent-dev, python-all-dev, python-support, python-psycopg2, xmlto, asciidoc, libpq-dev, postgresql-server-dev-8.4, postgresql-server-dev-9.0
Standards-Version: 3.9.1
Homepage: http://wiki.postgresql.org/wiki/Skytools
Vcs-Git: http://github.com/markokr/skytools.git
Vcs-Browser: https://github.com/markokr/skytools

Package: skytools3
Architecture: any
Depends: ${misc:Depends}, ${python:Depends}, python-pgq3, adduser
Description: Skype tools for PostgreSQL replication, londiste and PGQ
 This is a package of tools in use in Skype for replication and failover. It
 contains the Londiste and PGQ services and scripts to run.

Package: python-pgq3
Architecture: any
Section: python
Depends: ${misc:Depends}, ${python:Depends}, python-skytools3, python-psycopg2
Description: python framework for Skype tools for PostgreSQL replication
 This is a package of tools in use in Skype for replication and failover.
 It includes a generic queuing mechanism PgQ and utility library for Python
 scripts.

Package: python-skytools3
Architecture: any
Section: python
Depends: ${shlibs:Depends}, ${misc:Depends}, ${python:Depends}
Suggests: python-psycopg2
Description: python framework for Skype tools for PostgreSQL replication
 This is a package of tools in use in Skype for replication and failover.
 It contains the Skytools' python framework for scripting against a
 PostgreSQL database, which is used by londiste, walmgr and PGQ.

Package: skytools3-walmgr
Architecture: any
Depends: ${misc:Depends}, ${python:Depends}, python-skytools3, postgresql-8.4 | postgresql-9.0
Enhances: postgresql-8.4, postgresql-9.0
Description: Skype tools for PostgreSQL replication and failover
 This is a package of tools in use in Skype for replication and failover.
 It's the WAL Shipping part of it (binary cluster-wide replication).

Package: skytools3-ticker
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Skype tools for PostgreSQL replication, londiste and PGQ
 This is the PGQ ticker used by Skype replication, londiste. It consists of
 PL/pgsql, and C code in database, with Python framework on top of it.  It
 is based on snapshot based event handling ideas from Slony-I, written for
 general usage.

Package: postgresql-8.4-pgq3
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, postgresql-8.4
Provides: skytools-modules
Conflicts: skytools-modules-8.4
Replaces: skytools-modules-8.4
Description: Skype tools for PostgreSQL replication, londiste and PGQ
 This is the PGQ extension used by Skype replication, londiste. It consists
 of PL/pgsql, and C code in database.

Package: postgresql-9.0-pgq3
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, postgresql-9.0
Provides: skytools-modules
Conflicts: skytools-modules-9.0
Replaces: skytools-modules-9.0
Description: Skype tools for PostgreSQL replication, londiste and PGQ
 This is the PGQ extension used by Skype replication, londiste. It consists
 of PL/pgsql, and C code in database.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
#
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.
#
# Modified to make a template file for a multi-binary package with separated
# build-arch and build-indep targets  by Bill Allombert 2001

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# This has to be exported to make some magic below work.
export DH_OPTIONS

# The build system is averse to VPATH building, so we can't use postgresql-server-dev-all
PG_CONFIG_84=/usr/lib/postgresql/8.4/bin/pg_config
PG_CONFIG_90=/usr/lib/postgresql/9.0/bin/pg_config
PKGVERS     = $(shell dpkg-parsechangelog | awk -F '[:-]' '/^Version:/ { print substr($$2, 2) }')
ORIG_EXCLUDE=--exclude-vcs --exclude=debian

config.mak:
	autoreconf -I lib/m4
	./configure --prefix=/usr --with-asciidoc

override_dh_auto_configure:

override_dh_auto_clean: config.mak
	make -C lib distclean
	make -C doc realclean
	dh_auto_clean -- distclean
	rm -rf $(SRCDIR)/debian
	rm -f upgrade/final/v3.0_pgq_core.sql

override_dh_auto_build: config.mak lib/build
	dh_auto_build -- SQLDIR=/usr/share/skytools3 PG_CONFIG=$(PG_CONFIG_90)
	make -C upgrade

# upstream build system will build fine for one given PostgreSQL version,
# then we build the PostgreSQL module and files for yet another version of
# it so that we have binary packages for postgresql-8.4-pgq3 and 9.0.
override_dh_auto_install: 
	mkdir -p $(CURDIR)/debian/tmp
	cp -a upgrade/final/v3.0_pgq_core.sql $(CURDIR)/debian/tmp/pgq_core_upgrade_to_v3.0.sql
	dh_auto_install
	for d in sql/pgq sql/pgq_node sql/pgq_ext sql/pgq_coop sql/txid sql/londiste; do \
		make PG_CONFIG=$(PG_CONFIG_84) \
                     DESTDIR=$(CURDIR)/debian/tmp \
                     -C $$d clean install \
                || exit 1 ;\
	done

lib/build:
	chmod +x lib/find_modules.sh

orig: clean
	cd .. && tar czf skytools3_$(PKGVERS).orig.tar.gz $(ORIG_EXCLUDE) skytools

%:
	dh $@

## skytools3 3.1.3

=== Makefile ===

-include config.mak

PYTHON ?= python

pyver = $(shell $(PYTHON) -V 2>&1 | sed 's/^[^ ]* \([0-9]*\.[0-9]*\).*/\1/')

SUBDIRS = sql doc

# modules that use doctest for regtests
DOCTESTMODS = skytools.quoting skytools.parsing skytools.timeutil \
	   skytools.sqltools skytools.querybuilder skytools.natsort \
	   skytools.utf8 skytools.sockutil skytools.fileutil \
	   londiste.exec_attrs


all: python-all sub-all config.mak

install: sub-install python-install
distclean: sub-distclean
sub-all sub-install sub-clean sub-distclean:
	for dir in $(SUBDIRS); do \
		$(MAKE) -C $$dir $(subst sub-,,$@) DESTDIR=$(DESTDIR) || exit $?; \
	done

.PHONY: sub-all sub-clean sub-install sub-distclean

python-all: config.mak
	$(PYTHON) setup_skytools.py build

clean: sub-clean
	$(PYTHON) setup_skytools.py clean
	rm -rf build build.sk3
	find python -name '*.py[oc]' -print | xargs rm -f
	rm -f python/skytools/installer_config.py source.list
	rm -rf tests/londiste/sys
	rm -rf tests/londiste/file_logs
	rm -rf tests/londiste/fix.*
	rm -rf tests/scripts/sys


installcheck:
	$(MAKE) -C sql installcheck

modules-install: config.mak
	$(MAKE) -C sql install DESTDIR=$(DESTDIR)
	test \! -d compat || $(MAKE) -C compat $@ DESTDIR=$(DESTDIR)

SITEDIR = site-packages

python-install: config.mak
	$(PYTHON) setup_pkgloader.py install --prefix=$(prefix) --root=$(DESTDIR)/ $(BROKEN_PYTHON)
	$(PYTHON) setup_skytools.py install --prefix=$(prefix) --root=$(DESTDIR)/ $(BROKEN_PYTHON)
	$(MAKE) -C doc DESTDIR=$(DESTDIR) install

realclean: distclean
	$(MAKE) -C doc $@
	$(MAKE) distclean

distclean: sub-distclean
	rm -rf source.list dist skytools-*
	find python -name '*.pyc' | xargs rm -f
	rm -rf dist build
	rm -rf autom4te.cache config.log config.status config.mak

deb:
	debuild -uc -us -b

tgz: config.mak clean
	$(MAKE) -C doc man
	rm -f source.list
	$(PYTHON) setup_skytools.py sdist -t source.cfg -m source.list

debclean: distclean
	rm -rf debian/tmp-* debian/build* debian/control debian/packages-tmp*
	rm -f debian/files debian/rules debian/sub* debian/packages

boot: configure

configure: configure.ac lib/m4/usual.m4
	./autogen.sh

tags:
	ctags `find python -name '*.py'`

check:
	./misc/docheck.sh

# workaround for Debian's broken python
debfix:
	@$(PYTHON) setup_skytools.py install --help | grep -q install-layout \
	&& echo BROKEN_PYTHON=--install-layout=deb || echo 'WORKING_PYTHON=found'

.PHONY: all clean distclean install deb debclean tgz tags
.PHONY: python-all python-clean python-install check test

test:
	@cd python; for m in $(DOCTESTMODS); do \
		printf "%-22s ... " $$m; \
		$(PYTHON) -m $$m && echo "ok" || { echo "FAIL"; exit 1; }; \
	done

=== sql/londiste/Makefile ===

EXTENSION = londiste

EXT_VERSION = 3.1.3
EXT_OLD_VERSIONS = 3.1 3.1.1

base_regress = londiste_provider londiste_subscriber \
	       londiste_fkeys londiste_execute londiste_seqs londiste_merge \
	       londiste_leaf londiste_create_part

Contrib_regress = init_noext $(base_regress)
Extension_regress = init_ext $(base_regress)

include ../common-pgxs.mk

dox: cleandox
	mkdir -p docs/html
	mkdir -p docs/sql
	$(CATSQL) --ndoc structure/tables.sql > docs/sql/schema.sql
	$(CATSQL) --ndoc structure/functions.sql > docs/sql/functions.sql
	$(NDOC) $(NDOCARGS)

=== sql/pgq/Makefile ===

EXTENSION = pgq

EXT_VERSION = 3.1.3
EXT_OLD_VERSIONS = 3.1 3.1.1 3.1.2

DOCS = README.pgq

PGQ_TESTS = pgq_core pgq_perms logutriga sqltriga $(trunc_test)

# comment it out if not wanted
UPGRADE_TESTS = pgq_init_upgrade $(PGQ_TESTS) clean

Contrib_data = structure/uninstall_pgq.sql

Contrib_regress   = $(UPGRADE_TESTS) pgq_init_noext $(PGQ_TESTS)
Extension_regress = $(UPGRADE_TESTS) pgq_init_ext $(PGQ_TESTS)

# MAJORVERSION was defined in 8.4
trunc_test = $(if $(MAJORVERSION),trunctrg)

include ../common-pgxs.mk

SUBDIRS = lowlevel triggers

# PGXS does not have subdir support, thus hack to recurse into lowlevel/
all: sub-all
install: sub-install
clean: sub-clean
distclean: sub-distclean
sub-all sub-install sub-clean sub-distclean:
	for dir in $(SUBDIRS); do \
		$(MAKE) -C $$dir $(subst sub-,,$@) \
			DESTDIR=$(DESTDIR) \
			PG_CONFIG=$(PG_CONFIG) \
		|| exit 1; \
	done

lowlevel/pgq_lowlevel.sql: sub-all
triggers/pgq_triggers.sql: sub-all

#
# docs
#
dox: cleandox $(SRCS)
	mkdir -p docs/html
	mkdir -p docs/sql
	$(CATSQL) --ndoc structure/tables.sql > docs/sql/schema.sql
	$(CATSQL) --ndoc structure/func_public.sql > docs/sql/external.sql
	$(CATSQL) --ndoc structure/func_internal.sql > docs/sql/internal.sql
	$(CATSQL) --ndoc structure/triggers.sql > docs/sql/triggers.sql
	$(NDOC) $(NDOCARGS)

=== debian/changelog ===
skytools3 (3.1.3-1.pgdg+1) sid-pgdg; urgency=low

  * Rebuild for sid-pgdg (jenkins-skytools3-source-distribution=sid-3,
    git revision d7002d56fd355bf8df99996345024cf49e6cd08c)

 -- apt.postgresql.org autobuilder <myon@debian.org>  Fri, 08 Feb 2013 14:06:28 +0100

skytools3 (3.1.3-1) experimental; urgency=low

  * New upstream version.
  * Includes packaging fixes from Dimitri and Marko.
  * Properly uses pg_buildext (Closes: #644540, #694030)
  * Depends on python-psycopg2 (Closes: #652344)

 -- Christoph Berg <myon@debian.org>  Fri, 08 Feb 2013 14:02:25 +0100

skytools3 (3.0~rc2-1) experimental; urgency=low

  * Fix skytools3-walmgr dependencies (support 9.1)
  * Bug fixes upstream

 -- Dimitri Fontaine <dim@tapoueh.org>  Tue, 11 Oct 2011 12:06:54 +0200

=== debian/control ===
--- 
+++ 
@@ -2,8 +2,10 @@
 Section: database
 Priority: extra
 Maintainer: Dimitri Fontaine <dim@tapoueh.org>
-Build-Depends: debhelper (>= 7.0.50~), autotools-dev, autoconf (>= 2.65), automake, libevent-dev, python-all-dev, python-support, python-psycopg2, xmlto, asciidoc, libpq-dev, postgresql-server-dev-8.4, postgresql-server-dev-9.0
-Standards-Version: 3.9.1
+Uploaders: Christoph Berg <myon@debian.org>
+Build-Depends: debhelper (>= 7.0.50~), autotools-dev, autoconf (>= 2.65), automake, libtool, libevent-dev,
+  python-all-dev, python-support, python-psycopg2, xmlto, asciidoc, libpq-dev, postgresql-server-dev-all
+Standards-Version: 3.9.3
 Homepage: http://wiki.postgresql.org/wiki/Skytools
 Vcs-Git: http://github.com/markokr/skytools.git
 Vcs-Browser: https://github.com/markokr/skytools
@@ -36,8 +38,8 @@
 
 Package: skytools3-walmgr
 Architecture: any
-Depends: ${misc:Depends}, ${python:Depends}, python-skytools3, postgresql-8.4 | postgresql-9.0
-Enhances: postgresql-8.4, postgresql-9.0
+Depends: ${misc:Depends}, ${python:Depends}, python-skytools3, postgresql
+Enhances: postgresql-8.4, postgresql-9.0, postgresql-9.1
 Description: Skype tools for PostgreSQL replication and failover
  This is a package of tools in use in Skype for replication and failover.
  It's the WAL Shipping part of it (binary cluster-wide replication).
@@ -50,6 +52,16 @@
  PL/pgsql, and C code in database, with Python framework on top of it.  It
  is based on snapshot based event handling ideas from Slony-I, written for
  general usage.
+
+Package: postgresql-8.3-pgq3
+Architecture: any
+Depends: ${shlibs:Depends}, ${misc:Depends}, postgresql-8.3
+Provides: skytools-modules
+Conflicts: skytools-modules-8.3
+Replaces: skytools-modules-8.3
+Description: Skype tools for PostgreSQL replication, londiste and PGQ
+ This is the PGQ extension used by Skype replication, londiste. It consists
+ of PL/pgsql, and C code in database.
 
 Package: postgresql-8.4-pgq3
 Architecture: any
@@ -70,3 +82,24 @@
 Description: Skype tools for PostgreSQL replication, londiste and PGQ
  This is the PGQ extension used by Skype replication, londiste. It consists
  of PL/pgsql, and C code in database.
+
+Package: postgresql-9.1-pgq3
+Architecture: any
+Depends: ${shlibs:Depends}, ${misc:Depends}, postgresql-9.1
+Provides: skytools-modules
+Conflicts: skytools-modules-9.1
+Replaces: skytools-modules-9.1
+Description: Skype tools for PostgreSQL replication, londiste and PGQ
+ This is the PGQ extension used by Skype replication, londiste. It consists
+ of PL/pgsql, and C code in database.
+
+Package: postgresql-9.2-pgq3
+Architecture: any
+Depends: ${shlibs:Depends}, ${misc:Depends}, postgresql-9.2
+Provides: skytools-modules
+Conflicts: skytools-modules-9.2
+Replaces: skytools-modules-9.2
+Description: Skype tools for PostgreSQL replication, londiste and PGQ
+ This is the PGQ extension used by Skype replication, londiste. It consists
+ of PL/pgsql, and C code in database.
+

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

SRCDIR      = $(CURDIR)
PKGVERS     = $(shell dpkg-parsechangelog | awk -F '[:-]' '/^Version:/ { print substr($$2, 2) }')
ORIG_EXCLUDE=--exclude-vcs --exclude=debian

PG_BUILDEXT = pg_buildext

include /usr/share/postgresql-common/pgxs_debian_control.mk
# force rebuilding
.PHONY: debian/control
clean: debian/control

config.mak:
	#./autogen.sh
	./configure --prefix=/usr --with-asciidoc --with-sk3-subdir

override_dh_auto_configure: config.mak

override_dh_auto_clean: config.mak
	$(MAKE) -C doc realclean
	dh_auto_clean -- distclean
	rm -rf build.sk3 lib/usual/config.h scripts/*.pyc sql/pgq/*/*.so* python/skytools/installer_config.py
	for version in `cat $(CURDIR)/debian/pgversions`; do \
		rm -rf "debian/postgresql-$${version}-pgq3"; \
	done

# build sql modules for several postgres versions
override_dh_auto_install: config.mak
	mkdir -p $(CURDIR)/debian/tmp
	dh_auto_install
	$(MAKE) -C doc htmlinstall DESTDIR=$(CURDIR)/debian/tmp
	# now care about any previous supported versions
	for version in $$($(PG_BUILDEXT) supported-versions $(CURDIR)); do \
		echo "### Building for PostgreSQL $$version" && \
		make -C sql clean install \
			PG_CONFIG=/usr/lib/postgresql/$$version/bin/pg_config \
			DESTDIR=$(CURDIR)/debian/tmp \
		|| exit 1 ; \
	done

orig: config.mak
	rm -rf dist
	make tgz
	mv dist/*.tar.gz ../skytools3_$(PKGVERS).orig.tar.gz

%:
	dh $@
